import 'util.dart';

enum ColorType {
  basic,
  standard,
}

class ColorSwatchProperty {
  ColorProperty? primary;
  List<ColorProperty> swatches = List<ColorProperty>.empty(
    growable: true,
  );

  ColorSwatchProperty({
    this.primary,
  });
}

class ColorProperty {
  final ColorType type;
  final String name;
  final String index;
  final String hex;

  ColorProperty({
    required this.type,
    required this.name,
    required this.index,
    required this.hex,
  });

  factory ColorProperty.fromLine(String key, String value) {
    List<String> keys = key.split('-');

    // remove first
    keys.removeAt(0);

    // get index
    String index = keys.removeLast();

    // get type
    ColorType type = ColorType.standard;

    // if the keys contain basic keyword, use color type basic
    if (keys.contains('basic')) {
      type = ColorType.basic;
    }

    // Camelize name
    String name = '';
    for (int i = 0; i < keys.length; i++) {
      if (i > 0) {
        // capitalize second words or later
        name += keys[i][0].toUpperCase() + keys[i].substring(1);
      } else {
        name += keys[i];
      }
    }

    // get hex
    String hex = hexToIntHex(value);

    return ColorProperty(
      index: index,
      name: name,
      type: type,
      hex: hex,
    );
  }
}
